-------------------------------------------------
--  MEMORY MODULE
--  Dependencies: none
--  By: Simon Foucher
-------------------------------------------------








library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

ENTITY MEM_STAGE IS
      PORT(
         ADDRESS     : in  std_logic_vector(63 downto 0);
 	      MemRead     : in std_logic;
  	      MemWrite    : in std_logic;
  	      RST   : in std_logic;
 	      INData	   : in std_logic_vector (63 downto 0);
 	      OUTData	  : out std_logic_vector (63 downto 0));
       
       
END MEM_STAGE;


ARCHITECTURE logic OF MEM_STAGE IS


-- Memory cells
SIGNAL CELL0x00000000 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000001 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000002 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000003 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000004 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000005 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000006 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000007 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000008 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000009 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000000a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000000b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000000c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000000d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000000e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000000f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000010 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000011 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000012 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000013 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000014 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000015 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000016 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000017 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000018 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000019 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000001a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000001b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000001c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000001d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000001e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000001f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000020 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000021 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000022 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000023 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000024 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000025 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000026 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000027 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000028 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000029 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000002a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000002b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000002c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000002d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000002e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000002f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000030 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000031 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000032 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000033 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000034 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000035 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000036 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000037 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000038 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000039 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000003a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000003b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000003c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000003d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000003e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000003f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000040 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000041 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000042 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000043 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000044 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000045 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000046 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000047 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000048 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000049 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000004a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000004b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000004c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000004d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000004e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000004f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000050 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000051 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000052 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000053 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000054 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000055 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000056 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000057 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000058 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000059 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000005a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000005b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000005c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000005d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000005e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000005f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000060 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000061 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000062 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000063 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000064 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000065 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000066 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000067 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000068 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000069 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000006a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000006b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000006c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000006d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000006e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000006f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000070 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000071 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000072 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000073 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000074 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000075 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000076 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000077 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000078 : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000079 : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000007a : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000007b : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000007c : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000007d : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000007e : std_logic_vector (63 downto 0);
SIGNAL CELL0x0000007f : std_logic_vector (63 downto 0);
SIGNAL CELL0x00000080 : std_logic_vector (63 downto 0);



BEGIN
   
   
  
   
PROCESS(RST, ADDRESS, MemRead, MemWrite, INData)
    
BEGIN

IF RST = '1' THEN
CELL0x00000000 <= x"0000000000000000";
CELL0x00000001 <= x"0000000000000000";
CELL0x00000002 <= x"0000000000000000";
CELL0x00000003 <= x"0000000000000000";
CELL0x00000004 <= x"0000000000000000";
CELL0x00000005 <= x"0000000000000000";
CELL0x00000006 <= x"0000000000000000";
CELL0x00000007 <= x"0000000000000000";
CELL0x00000008 <= x"0000000000000000";
CELL0x00000009 <= x"0000000000000000";
CELL0x0000000a <= x"0000000000000000";
CELL0x0000000b <= x"0000000000000000";
CELL0x0000000c <= x"0000000000000000";
CELL0x0000000d <= x"0000000000000000";
CELL0x0000000e <= x"0000000000000000";
CELL0x0000000f <= x"0000000000000000";
CELL0x00000010 <= x"0000000000000000";
CELL0x00000011 <= x"0000000000000000";
CELL0x00000012 <= x"0000000000000000";
CELL0x00000013 <= x"0000000000000000";
CELL0x00000014 <= x"0000000000000000";
CELL0x00000015 <= x"0000000000000000";
CELL0x00000016 <= x"0000000000000000";
CELL0x00000017 <= x"0000000000000000";
CELL0x00000018 <= x"0000000000000000";
CELL0x00000019 <= x"0000000000000000";
CELL0x0000001a <= x"0000000000000000";
CELL0x0000001b <= x"0000000000000000";
CELL0x0000001c <= x"0000000000000000";
CELL0x0000001d <= x"0000000000000000";
CELL0x0000001e <= x"0000000000000000";
CELL0x0000001f <= x"0000000000000000";
CELL0x00000020 <= x"0000000000000000";
CELL0x00000021 <= x"0000000000000000";
CELL0x00000022 <= x"0000000000000000";
CELL0x00000023 <= x"0000000000000000";
CELL0x00000024 <= x"0000000000000000";
CELL0x00000025 <= x"0000000000000000";
CELL0x00000026 <= x"0000000000000000";
CELL0x00000027 <= x"0000000000000000";
CELL0x00000028 <= x"0000000000000000";
CELL0x00000029 <= x"0000000000000000";
CELL0x0000002a <= x"0000000000000000";
CELL0x0000002b <= x"0000000000000000";
CELL0x0000002c <= x"0000000000000000";
CELL0x0000002d <= x"0000000000000000";
CELL0x0000002e <= x"0000000000000000";
CELL0x0000002f <= x"0000000000000000";
CELL0x00000030 <= x"0000000000000000";
CELL0x00000031 <= x"0000000000000000";
CELL0x00000032 <= x"0000000000000000";
CELL0x00000033 <= x"0000000000000000";
CELL0x00000034 <= x"0000000000000000";
CELL0x00000035 <= x"0000000000000000";
CELL0x00000036 <= x"0000000000000000";
CELL0x00000037 <= x"0000000000000000";
CELL0x00000038 <= x"0000000000000000";
CELL0x00000039 <= x"0000000000000000";
CELL0x0000003a <= x"0000000000000000";
CELL0x0000003b <= x"0000000000000000";
CELL0x0000003c <= x"0000000000000000";
CELL0x0000003d <= x"0000000000000000";
CELL0x0000003e <= x"0000000000000000";
CELL0x0000003f <= x"0000000000000000";
CELL0x00000040 <= x"0000000000000000";
CELL0x00000041 <= x"0000000000000000";
CELL0x00000042 <= x"0000000000000000";
CELL0x00000043 <= x"0000000000000000";
CELL0x00000044 <= x"0000000000000000";
CELL0x00000045 <= x"0000000000000000";
CELL0x00000046 <= x"0000000000000000";
CELL0x00000047 <= x"0000000000000000";
CELL0x00000048 <= x"0000000000000000";
CELL0x00000049 <= x"0000000000000000";
CELL0x0000004a <= x"0000000000000000";
CELL0x0000004b <= x"0000000000000000";
CELL0x0000004c <= x"0000000000000000";
CELL0x0000004d <= x"0000000000000000";
CELL0x0000004e <= x"0000000000000000";
CELL0x0000004f <= x"0000000000000000";
CELL0x00000050 <= x"0000000000000000";
CELL0x00000051 <= x"0000000000000000";
CELL0x00000052 <= x"0000000000000000";
CELL0x00000053 <= x"0000000000000000";
CELL0x00000054 <= x"0000000000000000";
CELL0x00000055 <= x"0000000000000000";
CELL0x00000056 <= x"0000000000000000";
CELL0x00000057 <= x"0000000000000000";
CELL0x00000058 <= x"0000000000000000";
CELL0x00000059 <= x"0000000000000000";
CELL0x0000005a <= x"0000000000000000";
CELL0x0000005b <= x"0000000000000000";
CELL0x0000005c <= x"0000000000000000";
CELL0x0000005d <= x"0000000000000000";
CELL0x0000005e <= x"0000000000000000";
CELL0x0000005f <= x"0000000000000000";
CELL0x00000060 <= x"0000000000000000";
CELL0x00000061 <= x"0000000000000000";
CELL0x00000062 <= x"0000000000000000";
CELL0x00000063 <= x"0000000000000000";
CELL0x00000064 <= x"0000000000000000";
CELL0x00000065 <= x"0000000000000000";
CELL0x00000066 <= x"0000000000000000";
CELL0x00000067 <= x"0000000000000000";
CELL0x00000068 <= x"0000000000000000";
CELL0x00000069 <= x"0000000000000000";
CELL0x0000006a <= x"0000000000000000";
CELL0x0000006b <= x"0000000000000000";
CELL0x0000006c <= x"0000000000000000";
CELL0x0000006d <= x"0000000000000000";
CELL0x0000006e <= x"0000000000000000";
CELL0x0000006f <= x"0000000000000000";
CELL0x00000070 <= x"0000000000000000";
CELL0x00000071 <= x"0000000000000000";
CELL0x00000072 <= x"0000000000000000";
CELL0x00000073 <= x"0000000000000000";
CELL0x00000074 <= x"0000000000000000";
CELL0x00000075 <= x"0000000000000000";
CELL0x00000076 <= x"0000000000000000";
CELL0x00000077 <= x"0000000000000000";
CELL0x00000078 <= x"0000000000000000";
CELL0x00000079 <= x"0000000000000000";
CELL0x0000007a <= x"0000000000000000";
CELL0x0000007b <= x"0000000000000000";
CELL0x0000007c <= x"0000000000000000";
CELL0x0000007d <= x"0000000000000000";
CELL0x0000007e <= x"0000000000000000";
CELL0x0000007f <= x"0000000000000000";
CELL0x00000080 <= x"0000000000000000";



ELSIF MemRead = '1' THEN
	CASE ADDRESS IS
        WHEN x"0000000000000000" => OUTData <= CELL0x00000000;
        WHEN x"0000000000000001" => OUTData <= CELL0x00000001;
        WHEN x"0000000000000002" => OUTData <= CELL0x00000002;
        WHEN x"0000000000000003" => OUTData <= CELL0x00000003;
        WHEN x"0000000000000004" => OUTData <= CELL0x00000004;
        WHEN x"0000000000000005" => OUTData <= CELL0x00000005;
        WHEN x"0000000000000006" => OUTData <= CELL0x00000006;
        WHEN x"0000000000000007" => OUTData <= CELL0x00000007;
        WHEN x"0000000000000008" => OUTData <= CELL0x00000008;
        WHEN x"0000000000000009" => OUTData <= CELL0x00000009;
        WHEN x"000000000000000a" => OUTData <= CELL0x0000000a;
        WHEN x"000000000000000b" => OUTData <= CELL0x0000000b;
        WHEN x"000000000000000c" => OUTData <= CELL0x0000000c;
        WHEN x"000000000000000d" => OUTData <= CELL0x0000000d;
        WHEN x"000000000000000e" => OUTData <= CELL0x0000000e;
        WHEN x"000000000000000f" => OUTData <= CELL0x0000000f;
        WHEN x"0000000000000010" => OUTData <= CELL0x00000010;
        WHEN x"0000000000000011" => OUTData <= CELL0x00000011;
        WHEN x"0000000000000012" => OUTData <= CELL0x00000012;
        WHEN x"0000000000000013" => OUTData <= CELL0x00000013;
        WHEN x"0000000000000014" => OUTData <= CELL0x00000014;
        WHEN x"0000000000000015" => OUTData <= CELL0x00000015;
        WHEN x"0000000000000016" => OUTData <= CELL0x00000016;
        WHEN x"0000000000000017" => OUTData <= CELL0x00000017;
        WHEN x"0000000000000018" => OUTData <= CELL0x00000018;
        WHEN x"0000000000000019" => OUTData <= CELL0x00000019;
        WHEN x"000000000000001a" => OUTData <= CELL0x0000001a;
        WHEN x"000000000000001b" => OUTData <= CELL0x0000001b;
        WHEN x"000000000000001c" => OUTData <= CELL0x0000001c;
        WHEN x"000000000000001d" => OUTData <= CELL0x0000001d;
        WHEN x"000000000000001e" => OUTData <= CELL0x0000001e;
        WHEN x"000000000000001f" => OUTData <= CELL0x0000001f;
        WHEN x"0000000000000020" => OUTData <= CELL0x00000020;
        WHEN x"0000000000000021" => OUTData <= CELL0x00000021;
        WHEN x"0000000000000022" => OUTData <= CELL0x00000022;
        WHEN x"0000000000000023" => OUTData <= CELL0x00000023;
        WHEN x"0000000000000024" => OUTData <= CELL0x00000024;
        WHEN x"0000000000000025" => OUTData <= CELL0x00000025;
        WHEN x"0000000000000026" => OUTData <= CELL0x00000026;
        WHEN x"0000000000000027" => OUTData <= CELL0x00000027;
        WHEN x"0000000000000028" => OUTData <= CELL0x00000028;
        WHEN x"0000000000000029" => OUTData <= CELL0x00000029;
        WHEN x"000000000000002a" => OUTData <= CELL0x0000002a;
        WHEN x"000000000000002b" => OUTData <= CELL0x0000002b;
        WHEN x"000000000000002c" => OUTData <= CELL0x0000002c;
        WHEN x"000000000000002d" => OUTData <= CELL0x0000002d;
        WHEN x"000000000000002e" => OUTData <= CELL0x0000002e;
        WHEN x"000000000000002f" => OUTData <= CELL0x0000002f;
        WHEN x"0000000000000030" => OUTData <= CELL0x00000030;
        WHEN x"0000000000000031" => OUTData <= CELL0x00000031;
        WHEN x"0000000000000032" => OUTData <= CELL0x00000032;
        WHEN x"0000000000000033" => OUTData <= CELL0x00000033;
        WHEN x"0000000000000034" => OUTData <= CELL0x00000034;
        WHEN x"0000000000000035" => OUTData <= CELL0x00000035;
        WHEN x"0000000000000036" => OUTData <= CELL0x00000036;
        WHEN x"0000000000000037" => OUTData <= CELL0x00000037;
        WHEN x"0000000000000038" => OUTData <= CELL0x00000038;
        WHEN x"0000000000000039" => OUTData <= CELL0x00000039;
        WHEN x"000000000000003a" => OUTData <= CELL0x0000003a;
        WHEN x"000000000000003b" => OUTData <= CELL0x0000003b;
        WHEN x"000000000000003c" => OUTData <= CELL0x0000003c;
        WHEN x"000000000000003d" => OUTData <= CELL0x0000003d;
        WHEN x"000000000000003e" => OUTData <= CELL0x0000003e;
        WHEN x"000000000000003f" => OUTData <= CELL0x0000003f;
        WHEN x"0000000000000040" => OUTData <= CELL0x00000040;
        WHEN x"0000000000000041" => OUTData <= CELL0x00000041;
        WHEN x"0000000000000042" => OUTData <= CELL0x00000042;
        WHEN x"0000000000000043" => OUTData <= CELL0x00000043;
        WHEN x"0000000000000044" => OUTData <= CELL0x00000044;
        WHEN x"0000000000000045" => OUTData <= CELL0x00000045;
        WHEN x"0000000000000046" => OUTData <= CELL0x00000046;
        WHEN x"0000000000000047" => OUTData <= CELL0x00000047;
        WHEN x"0000000000000048" => OUTData <= CELL0x00000048;
        WHEN x"0000000000000049" => OUTData <= CELL0x00000049;
        WHEN x"000000000000004a" => OUTData <= CELL0x0000004a;
        WHEN x"000000000000004b" => OUTData <= CELL0x0000004b;
        WHEN x"000000000000004c" => OUTData <= CELL0x0000004c;
        WHEN x"000000000000004d" => OUTData <= CELL0x0000004d;
        WHEN x"000000000000004e" => OUTData <= CELL0x0000004e;
        WHEN x"000000000000004f" => OUTData <= CELL0x0000004f;
        WHEN x"0000000000000050" => OUTData <= CELL0x00000050;
        WHEN x"0000000000000051" => OUTData <= CELL0x00000051;
        WHEN x"0000000000000052" => OUTData <= CELL0x00000052;
        WHEN x"0000000000000053" => OUTData <= CELL0x00000053;
        WHEN x"0000000000000054" => OUTData <= CELL0x00000054;
        WHEN x"0000000000000055" => OUTData <= CELL0x00000055;
        WHEN x"0000000000000056" => OUTData <= CELL0x00000056;
        WHEN x"0000000000000057" => OUTData <= CELL0x00000057;
        WHEN x"0000000000000058" => OUTData <= CELL0x00000058;
        WHEN x"0000000000000059" => OUTData <= CELL0x00000059;
        WHEN x"000000000000005a" => OUTData <= CELL0x0000005a;
        WHEN x"000000000000005b" => OUTData <= CELL0x0000005b;
        WHEN x"000000000000005c" => OUTData <= CELL0x0000005c;
        WHEN x"000000000000005d" => OUTData <= CELL0x0000005d;
        WHEN x"000000000000005e" => OUTData <= CELL0x0000005e;
        WHEN x"000000000000005f" => OUTData <= CELL0x0000005f;
        WHEN x"0000000000000060" => OUTData <= CELL0x00000060;
        WHEN x"0000000000000061" => OUTData <= CELL0x00000061;
        WHEN x"0000000000000062" => OUTData <= CELL0x00000062;
        WHEN x"0000000000000063" => OUTData <= CELL0x00000063;
        WHEN x"0000000000000064" => OUTData <= CELL0x00000064;
        WHEN x"0000000000000065" => OUTData <= CELL0x00000065;
        WHEN x"0000000000000066" => OUTData <= CELL0x00000066;
        WHEN x"0000000000000067" => OUTData <= CELL0x00000067;
        WHEN x"0000000000000068" => OUTData <= CELL0x00000068;
        WHEN x"0000000000000069" => OUTData <= CELL0x00000069;
        WHEN x"000000000000006a" => OUTData <= CELL0x0000006a;
        WHEN x"000000000000006b" => OUTData <= CELL0x0000006b;
        WHEN x"000000000000006c" => OUTData <= CELL0x0000006c;
        WHEN x"000000000000006d" => OUTData <= CELL0x0000006d;
        WHEN x"000000000000006e" => OUTData <= CELL0x0000006e;
        WHEN x"000000000000006f" => OUTData <= CELL0x0000006f;
        WHEN x"0000000000000070" => OUTData <= CELL0x00000070;
        WHEN x"0000000000000071" => OUTData <= CELL0x00000071;
        WHEN x"0000000000000072" => OUTData <= CELL0x00000072;
        WHEN x"0000000000000073" => OUTData <= CELL0x00000073;
        WHEN x"0000000000000074" => OUTData <= CELL0x00000074;
        WHEN x"0000000000000075" => OUTData <= CELL0x00000075;
        WHEN x"0000000000000076" => OUTData <= CELL0x00000076;
        WHEN x"0000000000000077" => OUTData <= CELL0x00000077;
        WHEN x"0000000000000078" => OUTData <= CELL0x00000078;
        WHEN x"0000000000000079" => OUTData <= CELL0x00000079;
        WHEN x"000000000000007a" => OUTData <= CELL0x0000007a;
        WHEN x"000000000000007b" => OUTData <= CELL0x0000007b;
        WHEN x"000000000000007c" => OUTData <= CELL0x0000007c;
        WHEN x"000000000000007d" => OUTData <= CELL0x0000007d;
        WHEN x"000000000000007e" => OUTData <= CELL0x0000007e;
        WHEN x"000000000000007f" => OUTData <= CELL0x0000007f;
        WHEN x"0000000000000080" => OUTData <= CELL0x00000080;
        WHEN OTHERS => OUTData <= x"ffffffffffffffff";       
   END CASE;


ELSIF MemWrite = '1' THEN
	CASE ADDRESS IS
        WHEN x"0000000000000000" => CELL0x00000000 <= INData;
        WHEN x"0000000000000001" => CELL0x00000001 <= INData;
        WHEN x"0000000000000002" => CELL0x00000002 <= INData;
        WHEN x"0000000000000003" => CELL0x00000003 <= INData;
        WHEN x"0000000000000004" => CELL0x00000004 <= INData;
        WHEN x"0000000000000005" => CELL0x00000005 <= INData;
        WHEN x"0000000000000006" => CELL0x00000006 <= INData;
        WHEN x"0000000000000007" => CELL0x00000007 <= INData;
        WHEN x"0000000000000008" => CELL0x00000008 <= INData;
        WHEN x"0000000000000009" => CELL0x00000009 <= INData;
        WHEN x"000000000000000a" => CELL0x0000000a <= INData;
        WHEN x"000000000000000b" => CELL0x0000000b <= INData;
        WHEN x"000000000000000c" => CELL0x0000000c <= INData;
        WHEN x"000000000000000d" => CELL0x0000000d <= INData;
        WHEN x"000000000000000e" => CELL0x0000000e <= INData;
        WHEN x"000000000000000f" => CELL0x0000000f <= INData;
        WHEN x"0000000000000010" => CELL0x00000010 <= INData;
        WHEN x"0000000000000011" => CELL0x00000011 <= INData;
        WHEN x"0000000000000012" => CELL0x00000012 <= INData;
        WHEN x"0000000000000013" => CELL0x00000013 <= INData;
        WHEN x"0000000000000014" => CELL0x00000014 <= INData;
        WHEN x"0000000000000015" => CELL0x00000015 <= INData;
        WHEN x"0000000000000016" => CELL0x00000016 <= INData;
        WHEN x"0000000000000017" => CELL0x00000017 <= INData;
        WHEN x"0000000000000018" => CELL0x00000018 <= INData;
        WHEN x"0000000000000019" => CELL0x00000019 <= INData;
        WHEN x"000000000000001a" => CELL0x0000001a <= INData;
        WHEN x"000000000000001b" => CELL0x0000001b <= INData;
        WHEN x"000000000000001c" => CELL0x0000001c <= INData;
        WHEN x"000000000000001d" => CELL0x0000001d <= INData;
        WHEN x"000000000000001e" => CELL0x0000001e <= INData;
        WHEN x"000000000000001f" => CELL0x0000001f <= INData;
        WHEN x"0000000000000020" => CELL0x00000020 <= INData;
        WHEN x"0000000000000021" => CELL0x00000021 <= INData;
        WHEN x"0000000000000022" => CELL0x00000022 <= INData;
        WHEN x"0000000000000023" => CELL0x00000023 <= INData;
        WHEN x"0000000000000024" => CELL0x00000024 <= INData;
        WHEN x"0000000000000025" => CELL0x00000025 <= INData;
        WHEN x"0000000000000026" => CELL0x00000026 <= INData;
        WHEN x"0000000000000027" => CELL0x00000027 <= INData;
        WHEN x"0000000000000028" => CELL0x00000028 <= INData;
        WHEN x"0000000000000029" => CELL0x00000029 <= INData;
        WHEN x"000000000000002a" => CELL0x0000002a <= INData;
        WHEN x"000000000000002b" => CELL0x0000002b <= INData;
        WHEN x"000000000000002c" => CELL0x0000002c <= INData;
        WHEN x"000000000000002d" => CELL0x0000002d <= INData;
        WHEN x"000000000000002e" => CELL0x0000002e <= INData;
        WHEN x"000000000000002f" => CELL0x0000002f <= INData;
        WHEN x"0000000000000030" => CELL0x00000030 <= INData;
        WHEN x"0000000000000031" => CELL0x00000031 <= INData;
        WHEN x"0000000000000032" => CELL0x00000032 <= INData;
        WHEN x"0000000000000033" => CELL0x00000033 <= INData;
        WHEN x"0000000000000034" => CELL0x00000034 <= INData;
        WHEN x"0000000000000035" => CELL0x00000035 <= INData;
        WHEN x"0000000000000036" => CELL0x00000036 <= INData;
        WHEN x"0000000000000037" => CELL0x00000037 <= INData;
        WHEN x"0000000000000038" => CELL0x00000038 <= INData;
        WHEN x"0000000000000039" => CELL0x00000039 <= INData;
        WHEN x"000000000000003a" => CELL0x0000003a <= INData;
        WHEN x"000000000000003b" => CELL0x0000003b <= INData;
        WHEN x"000000000000003c" => CELL0x0000003c <= INData;
        WHEN x"000000000000003d" => CELL0x0000003d <= INData;
        WHEN x"000000000000003e" => CELL0x0000003e <= INData;
        WHEN x"000000000000003f" => CELL0x0000003f <= INData;
        WHEN x"0000000000000040" => CELL0x00000040 <= INData;
        WHEN x"0000000000000041" => CELL0x00000041 <= INData;
        WHEN x"0000000000000042" => CELL0x00000042 <= INData;
        WHEN x"0000000000000043" => CELL0x00000043 <= INData;
        WHEN x"0000000000000044" => CELL0x00000044 <= INData;
        WHEN x"0000000000000045" => CELL0x00000045 <= INData;
        WHEN x"0000000000000046" => CELL0x00000046 <= INData;
        WHEN x"0000000000000047" => CELL0x00000047 <= INData;
        WHEN x"0000000000000048" => CELL0x00000048 <= INData;
        WHEN x"0000000000000049" => CELL0x00000049 <= INData;
        WHEN x"000000000000004a" => CELL0x0000004a <= INData;
        WHEN x"000000000000004b" => CELL0x0000004b <= INData;
        WHEN x"000000000000004c" => CELL0x0000004c <= INData;
        WHEN x"000000000000004d" => CELL0x0000004d <= INData;
        WHEN x"000000000000004e" => CELL0x0000004e <= INData;
        WHEN x"000000000000004f" => CELL0x0000004f <= INData;
        WHEN x"0000000000000050" => CELL0x00000050 <= INData;
        WHEN x"0000000000000051" => CELL0x00000051 <= INData;
        WHEN x"0000000000000052" => CELL0x00000052 <= INData;
        WHEN x"0000000000000053" => CELL0x00000053 <= INData;
        WHEN x"0000000000000054" => CELL0x00000054 <= INData;
        WHEN x"0000000000000055" => CELL0x00000055 <= INData;
        WHEN x"0000000000000056" => CELL0x00000056 <= INData;
        WHEN x"0000000000000057" => CELL0x00000057 <= INData;
        WHEN x"0000000000000058" => CELL0x00000058 <= INData;
        WHEN x"0000000000000059" => CELL0x00000059 <= INData;
        WHEN x"000000000000005a" => CELL0x0000005a <= INData;
        WHEN x"000000000000005b" => CELL0x0000005b <= INData;
        WHEN x"000000000000005c" => CELL0x0000005c <= INData;
        WHEN x"000000000000005d" => CELL0x0000005d <= INData;
        WHEN x"000000000000005e" => CELL0x0000005e <= INData;
        WHEN x"000000000000005f" => CELL0x0000005f <= INData;
        WHEN x"0000000000000060" => CELL0x00000060 <= INData;
        WHEN x"0000000000000061" => CELL0x00000061 <= INData;
        WHEN x"0000000000000062" => CELL0x00000062 <= INData;
        WHEN x"0000000000000063" => CELL0x00000063 <= INData;
        WHEN x"0000000000000064" => CELL0x00000064 <= INData;
        WHEN x"0000000000000065" => CELL0x00000065 <= INData;
        WHEN x"0000000000000066" => CELL0x00000066 <= INData;
        WHEN x"0000000000000067" => CELL0x00000067 <= INData;
        WHEN x"0000000000000068" => CELL0x00000068 <= INData;
        WHEN x"0000000000000069" => CELL0x00000069 <= INData;
        WHEN x"000000000000006a" => CELL0x0000006a <= INData;
        WHEN x"000000000000006b" => CELL0x0000006b <= INData;
        WHEN x"000000000000006c" => CELL0x0000006c <= INData;
        WHEN x"000000000000006d" => CELL0x0000006d <= INData;
        WHEN x"000000000000006e" => CELL0x0000006e <= INData;
        WHEN x"000000000000006f" => CELL0x0000006f <= INData;
        WHEN x"0000000000000070" => CELL0x00000070 <= INData;
        WHEN x"0000000000000071" => CELL0x00000071 <= INData;
        WHEN x"0000000000000072" => CELL0x00000072 <= INData;
        WHEN x"0000000000000073" => CELL0x00000073 <= INData;
        WHEN x"0000000000000074" => CELL0x00000074 <= INData;
        WHEN x"0000000000000075" => CELL0x00000075 <= INData;
        WHEN x"0000000000000076" => CELL0x00000076 <= INData;
        WHEN x"0000000000000077" => CELL0x00000077 <= INData;
        WHEN x"0000000000000078" => CELL0x00000078 <= INData;
        WHEN x"0000000000000079" => CELL0x00000079 <= INData;
        WHEN x"000000000000007a" => CELL0x0000007a <= INData;
        WHEN x"000000000000007b" => CELL0x0000007b <= INData;
        WHEN x"000000000000007c" => CELL0x0000007c <= INData;
        WHEN x"000000000000007d" => CELL0x0000007d <= INData;
        WHEN x"000000000000007e" => CELL0x0000007e <= INData;
        WHEN x"000000000000007f" => CELL0x0000007f <= INData;
        WHEN x"0000000000000080" => CELL0x00000080 <= INData;
		  WHEN OTHERS =>
      END CASE;

    
END IF;

END PROCESS;
     
    
END logic;
