------------------------------------------------------------------------
-- Filename: REG_IF_ID.vhd
-- Title: Register between stages IF and ID
-- Author: Simon Foucher
-- Date: February 2009
------------------------------------------------------------------------

library ieee;
use	ieee.std_logic_1164.all;
use	ieee.std_logic_arith.all;

ENTITY REG_IF_ID IS
      PORT(
      
		CLK	: in std_logic;
		RST : in std_logic;
		HAZARD	: in std_logic;
		INSTRUCTION_IN : in std_logic_vector(31 downto 0);
		INSTRUCTION_OUT : out std_logic_vector(31 downto 0));


END REG_IF_ID;


ARCHITECTURE logic OF REG_IF_ID IS
BEGIN



PROCESS(CLK)
BEGIN

IF rising_edge(CLK) THEN
	
	IF RST = '1' THEN
		INSTRUCTION_OUT <= x"00000000";
		
	ELSIF HAZARD = '0' THEN
		INSTRUCTION_OUT <= INSTRUCTION_IN;
		
	-- ELSE IF HAZARD = '1' THEN Memory mode
		

	END IF;
	
END IF;


END PROCESS;

END logic;
